package com.xhkjedu.sapi.controller.system;

import com.xhkjedu.sapi.model.system.TModuledefault;
import com.xhkjedu.sapi.service.system.ModuledefaultService;
import com.xhkjedu.utils.N_Utils;
import com.xhkjedu.vo.ResultVo;
import com.xhkjedu.sapi.vo.system.ModuleSelVo;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.List;

/**
* @author ywx
* @classname TModuledefaultController
* @description
* @date 2020/07/02 10:20
**/
@RestController
@RequestMapping("/moduledefault")
public class ModuledefaultController {
    @Resource
    private ModuledefaultService moduledefaultService;

    @PostMapping("/add")
    public ResultVo add(@RequestBody TModuledefault tModuledefault) {
        N_Utils.validation(new Object[]{tModuledefault.getModuletype(),"模块归属",1});
        return moduledefaultService.save(tModuledefault);
    }

    @PostMapping("/delete")
    public ResultVo delete(@RequestBody TModuledefault tModuledefault) {
        N_Utils.validation(new Object[]{tModuledefault.getModuleid(),"模块id",2});
        moduledefaultService.deleteById(tModuledefault.getModuleid());
        return new ResultVo(0,"删除成功");
    }

    @PostMapping("/update")
    public ResultVo update(@RequestBody TModuledefault tModuledefault) {
        moduledefaultService.update(tModuledefault);
        return new ResultVo(0,"修改成功");
    }

    @PostMapping("/detail")
    public ResultVo detail(@RequestBody TModuledefault tModuledefault) {
        N_Utils.validation(new Object[]{tModuledefault.getModuleid(),"模块id",2});
        TModuledefault moduledefault = moduledefaultService.findById(tModuledefault.getModuleid());
        return new ResultVo(0,"获取详情成功",moduledefault);
    }

    @PostMapping("/list")
    public ResultVo list(@RequestBody TModuledefault tModuledefault) {
        Integer moduletype = tModuledefault.getModuletype();
        N_Utils.validation(new Object[]{moduletype,"模块归属",1});
        List<TModuledefault> list = moduledefaultService.listAll(moduletype,tModuledefault.getDisplay());
        return new ResultVo(0,"获取列表成功",list);
    }

    /**
     *功能描述  首层模块
     * @author WN
     * @date 2020/6/15
     * @param  * @param module
     * @return com.xhkjedu.vo.ResultVo
     */
    @PostMapping("/listsel")
    public ResultVo listForSel(@RequestBody TModuledefault tModuledefault){
        Integer moduletype = tModuledefault.getModuletype();
        N_Utils.validation(new Object[]{moduletype,"模块归属",1});
        List<ModuleSelVo> lst = moduledefaultService.listLevelModule(moduletype);
        return new ResultVo(0,"获取一级应用成功",lst);
    }
}
